package com.gmail.berndivader.animatorstands;

import org.bukkit.scheduler.BukkitRunnable;

public class AnimatorClock {
	
	public AnimatorClock() {
		
		new BukkitRunnable() {
			private long cleanUpTick=600l, currentCleanUpTick=0l;
			private long aiClock=0l, currentAiTick=0l;
			
			@Override
			public void run() {
				this.currentCleanUpTick++;
				this.currentAiTick++;
				
				ArmorStandAnimator.animators.values().stream().forEach(animator->{
					animator.currentAnimTick++;
					if(animator.currentAnimTick>=animator.AnimClock) {
						animator.update();
						animator.currentAnimTick=0;
					}
					if(animator.hasAI()&&currentAiTick>=aiClock) ArmorStandAnimator.doAI(animator);
				});
				if(this.currentAiTick>=this.aiClock) this.currentAiTick=0l;
				
				if (this.currentCleanUpTick>=this.cleanUpTick) {
					this.currentCleanUpTick=0l;
					ArmorStandAnimator.animators.values().removeIf(e->{
						if(e.getArmorStand()==null||e.getArmorStand().isDead()) {
							if(e.hasAI()) e.aiMob.setDead();
							return true;
						}
						return false;
					});
				}
			}
			
		}.runTaskTimer(AnimatorStands.inst(),0l,0l);
		
	}
	
}
